﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace PojeClient {
    // 設定変更を行うフォーム．Settings の public static メンバを直接いじる．
    public partial class Form_ChangeSettings : Form {
        public Form_ChangeSettings() {
            InitializeComponent();
        }

        private void button_Cancel_Click(object sender, EventArgs e) {
            Logger.log("Settings change canceled.");
            this.Close();
        }

        // Settingsの中身を読んで画面に現在の値を表示
        private void Form_ChangeSettings_Shown(object sender, EventArgs e) {
            comboBox_ip.Text        = Settings.ConnectionIP;
            comboBox_port.Text      = Settings.ConnectionPort.ToString();
            comboBox_limittime.Text = Settings.LimitTime.ToString();
            comboBox_wait.Text      = Settings.TOTALWAIT.ToString();
            checkBox_showingNetLog.Checked = Settings.showingNetLog;
            checkBox_ailog.Checked         = Settings.showingAILog;
            checkBox_EnableServer.Checked  = Settings.enableStartAsServer;
            checkBox_AIRepeat.Checked      = Settings.repeatAIBattles;
            textBox_username.Text = Settings.userName;

            if (File.Exists("poje_settings.txt") == true) {
                bt_load.Enabled = true;
            } else {
                bt_load.Enabled = false;
            }
        }

        private void button_OK_Click(object sender, EventArgs e) {
            Settings.ConnectionIP = comboBox_ip.Text;
            Settings.ConnectionPort = Int32.Parse(comboBox_port.Text);
            Settings.LimitTime = Int32.Parse(comboBox_limittime.Text);
            Settings.TOTALWAIT = Int32.Parse(comboBox_wait.Text);
            Settings.showingNetLog = checkBox_showingNetLog.Checked;
            Settings.showingAILog = checkBox_ailog.Checked;
            Settings.enableStartAsServer = checkBox_EnableServer.Checked;
            Settings.repeatAIBattles = checkBox_AIRepeat.Checked;
            Settings.userName = textBox_username.Text;
            Logger.log("Settnigs changed");
            this.Close();
        }

        private void textBox_username_KeyUp(object sender, KeyEventArgs e) {
            if (textBox_username.Text.Length > 0) {
                textBox_username.Text = SGFManager.safeName(textBox_username.Text);
            }
        }

        private String boolToString(bool b) {
            if (b==true) {
                return "true";
            } else {
                return "false";
            }
        }

        private bool StringToBool(String s) {
            if (s.Equals("true") == true) {
                return true;
            } else {
                return false;
            }
        }

        // 設定をファイルに書き込む．
        private void bt_save_Click(object sender, EventArgs e) {
            using (StreamWriter sw = new StreamWriter("poje_settings.txt")) {
                sw.WriteLine("ConnectionIP " + comboBox_ip.Text);
                sw.WriteLine("ConnectionPort " + comboBox_port.Text);
                sw.WriteLine("LimitTime " + comboBox_limittime.Text);
                sw.WriteLine("TOTALWAIT " + comboBox_wait.Text);
                sw.WriteLine("showingNetLog " + boolToString(checkBox_showingNetLog.Checked));
                sw.WriteLine("showingAILog " + boolToString(checkBox_ailog.Checked));
                sw.WriteLine("enableStartAsServer " + boolToString(checkBox_EnableServer.Checked));
                sw.WriteLine("repeatAIBattles " + boolToString(checkBox_AIRepeat.Checked));
                sw.WriteLine("userName " + textBox_username.Text);
            }
            bt_load.Enabled = true;
            Logger.log("Settings saved to poje_settngs.txt");
        }

        // 設定をファイルから読み込む．一応，順番や書式の乱れを許す．
        private void bt_load_Click(object sender, EventArgs e) {
            if (File.Exists("poje_settings.txt") == false) {
                MessageBox.Show("poje_settings.txt doesn't exist.");
                return;
            }

            using (StreamReader sr = new StreamReader("poje_settings.txt")) {
                String line;
                while ((line = sr.ReadLine()) != null) {
                    if (line.Length < 3) continue;
                    if (line.IndexOf(" ") == -1) continue;
                    String[] words = line.Split(' ');
                    if (words[0].Equals("ConnectionIP") == true) comboBox_ip.Text = words[1];
                    if (words[0].Equals("ConnectionPort") == true) comboBox_port.Text = words[1];
                    if (words[0].Equals("LimitTime") == true) comboBox_limittime.Text = words[1];
                    if (words[0].Equals("TOTALWAIT") == true) comboBox_wait.Text = words[1];
                    if (words[0].Equals("showingNetLog") == true) checkBox_showingNetLog.Checked = StringToBool(words[1]);
                    if (words[0].Equals("showingAILog") == true) checkBox_ailog.Checked = StringToBool(words[1]);
                    if (words[0].Equals("enableStartAsServer") == true) checkBox_EnableServer.Checked = StringToBool(words[1]);
                    if (words[0].Equals("repeatAIBattles") == true) checkBox_AIRepeat.Checked = StringToBool(words[1]);
                    if (words[0].Equals("userName")==true) textBox_username.Text = SGFManager.safeName(words[1]);
                }
                Logger.log("Settings loaded from poje_settings.txt");
            }

        }

    }
}
