﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PojeClient {
    // ルールのパラメータが含まれるクラス
    // とりあえず public const あるいは public static readonly だが，一部表示関係などは変更できるようにしておく
    class Settings {
        public static int BoardWidth = 6;     
        public static int BoardHeight = 13;
        
        public const int NumColor = 4;
        public const int NumVanish = 4;
        public const int NextOpenTurns = 3;  // 現在の珠を含めて，何ターン分の配珠が見えているか
        public const int LimitTurnOfColorAbsent = 3;     // 3ターンの間（6珠中）に来ない色は次必ず来る
        public static readonly int[] JamCountByChain  = new int[21]{0, 0,6,18,36,60,  90,126,168,216,270,  330,396,468,546,630, 720,816,918,1026,1140};   // n連鎖時の基本邪魔珠数
        public static readonly int[] JamCountByAddition = new int[21]{0, 1,2,3,4,5, 6,7,8,9,10, 11,12,13,14,15, 16,17,18,19,20}; // n連鎖めに 5個以上消した場合のボーナス邪魔珠数
        public const int DrawTurn = 300;    // このターン数を超えると引き分け（人間ではあまりないと思うが，弱いAI用）

        public static int LimitTime = 10;
        public static int ConnectionPort = 9999;
        public static String ConnectionIP = "150.65.177.80";

        // 回転したときの向き
        public static readonly int[] RotateX = new int[4] { +1, 0, -1, 0 };
        public static readonly int[] RotateY = new int[4] { 0, +1, 0, -1 };
        public static readonly String[] RotateChars = new String[4] { "R", "U", "L", "D" };
    
        // netlog を表示するかどうか
        public static bool showingNetLog = false;

        // ailog を表示するかどうか
        public static bool showingAILog = false;

        // Start-as-server を表示するかどうか
        public static bool enableStartAsServer = false;


        // ユーザの名前
        public static String userName = "name";

        // AI 同士の戦いを繰り返すかどうか
        public static bool repeatAIBattles = false;
    
        // 表示ウェイト
        public static int TOTALWAIT = 5;
        public static int TOTALWAITtemp = 0;
        public static int SLEEPAFTER_DRAWACTION = 20;
        public static int SLEEPAFTER_DROP = 20;
        public static int SLEEPAFTER_SHOWCHAIN = 50;
        public static int SLEEPAFTER_VANISH = 20;
        public static int SLEEPAFTER_JAM = 30;

        public static int REPLAYWAIT = 1000;
    }
}
