﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PojeClient {
    // 意思決定に必要な，ゲームの状態を表すクラス
    class State {
        private int fTurn;
        private bool fNextsSynchronized;
        private Board[] fBoards;

        // コンストラクタ
        public State() {
            fBoards = new Board[2];
            fBoards[0] = new Board();
            fBoards[1] = new Board();
        }

        // コピーコンストラクタ
        public State(State src) {
            fTurn = src.getTurn();
            fNextsSynchronized = src.isNextSynchronized();
            fBoards = new Board[2] { new Board(src.getBoard(0)), new Board(src.getBoard(1)) };
        }



        // ゲームの初期化
        public void initialize(int[] nextColors) {
            fTurn = 0;
            fNextsSynchronized = true;
            fBoards[0].initialize(nextColors);
            fBoards[1].initialize(nextColors);
        }


        public Board getBoard(int idx) {
            return fBoards[idx];
        }

        public bool isNextSynchronized() {
            return fNextsSynchronized;
        }

        public void asynchronize() {
            fNextsSynchronized = false;
        }

        public void incTurn() {
            fTurn++;
        }

        public int getTurn() {
            return fTurn;
        }

    }
}
